Public              Cfg

SETTINGS Struct
    bAutoIndent     BOOL        ?
    bBOM            BOOL        ?
    bHideSelBar     BOOL        ?
    bHideSelection  BOOL        ?
    lEndOfLine      LONG        ?
    lTabSize        LONG        ?
    bTabToSpaces    BOOL        ?
    bSpacesToTab    BOOL        ?
    bToolbar        BOOL        ?
    bStatusbar      BOOL        ?
    crBackColor     COLORREF    ?
    crTextColor     COLORREF    ?
    crBackSelect    COLORREF    ?
    crTextSelect    COLORREF    ?
    crSelBarColor   COLORREF    ?
    crBackLocked    COLORREF    ?
    crTextLocked    COLORREF    ?
    szLastPath      WCHAR       MAX_PATH Dup(?)
    ef              RSSEDITFONT <?>
SETTINGS EndS

.Const

EM_CHANGESELECTION      Equ     WM_USER + 401
EM_FINDNEXTTEXT         Equ     WM_USER + 402
EM_SETFIRSTPOSITION     Equ     WM_USER + 403
EM_SETLASTPOSITION      Equ     WM_USER + 404
EM_SHOWFINDWINDOW       Equ     WM_USER + 405

RSM_GOTO_LINE           Equ     WM_USER + 1201

.Data?

szRegistryKey           Byte    128 Dup(?)
szAutoIndent            Byte    32 Dup(?)
szBOM                   Byte    32 Dup(?)
szHideSelBar            Byte    32 Dup(?)
szHideSelection         Byte    32 Dup(?)
szEndOfLine             Byte    32 Dup(?)
szTabSize               Byte    32 Dup(?)
szTabToSpaces           Byte    32 Dup(?)
szSpacesToTab           Byte    32 Dup(?)
szToolbar               Byte    32 Dup(?)
szStatusbar             Byte    32 Dup(?)
szBackColor             Byte    32 Dup(?)
szTextColor             Byte    32 Dup(?)
szSelBarColor           Byte    32 Dup(?)
szBackSelect            Byte    32 Dup(?)
szTextSelect            Byte    32 Dup(?)
szBackLocked            Byte    32 Dup(?)
szTextLocked            Byte    32 Dup(?)
szFontPoints            Byte    32 Dup(?)
szFontWeight            Byte    32 Dup(?)
szFontItalic            Byte    32 Dup(?)
szFontStrikethru        Byte    32 Dup(?)
szFontUnderline         Byte    32 Dup(?)
szFontCharSet           Byte    32 Dup(?)
szFontName              Byte    32 Dup(?)
szLastPath              Byte    32 Dup(?)

lpszCommon              LPSTR   ?

.Data

bAppUnicode             BOOL    FALSE
bMacroUntilEnd          BOOL    FALSE
bPlayingMacro           BOOL    FALSE
bSkipEmptyLines         BOOL    TRUE
bTextNotFound           BOOL    FALSE
bTextUnicode            BOOL    FALSE
lMacroTimes             LONG    0
hWndEditor              HWND    NULL
hWndSearch              HWND    NULL

fdir                    WIN32_FIND_DATAW <0>
Cfg                     SETTINGS    <0>

include ECProtos.inc ; .Code

EnableControl Proc Uses Ecx Edx Edi hDlg:HWND, uiID:UINT, bEnable:BOOL, bDefault:BOOL
    Invoke GetWindowItem, hDlg, uiID
    Mov Edi, Eax
    Invoke EnableWindow, Edi, bEnable
    Invoke SetDefault, Edi, bDefault
    Ret
EnableControl EndP

FileExists Proc Uses Esi lpszFileName:LPSTR, bCloseHandle:BOOL
    Lea Eax, fdir
    Push Eax
    Push lpszFileName
    .If bAppUnicode
        Call FindFirstFileW
    .Else
        Call FindFirstFileA
    .EndIf
    Cmp Eax, INVALID_HANDLE_VALUE
    Je @F
    Cmp bCloseHandle, 0
    Je @F
    Push Eax
    Invoke FindClose, Eax
    Pop Eax
@@: Ret
FileExists EndP

GetNoEllipsisString Proc Uses Ecx Edx Edi lpszString:LPSTR
    Invoke RSlstrlen, lpszString
    .If bAppUnicode
        Shl Eax, 1
    .EndIf
    Mov Edi, Eax
    Add Edi, lpszString
    Mov Eax, 3
    .If bAppUnicode
        Shl Eax, 1
    .EndIf
    Sub Edi, Eax
    .If bAppUnicode
        Mov Eax, TextAddrW("...")
    .Else
        Mov Eax, TextAddr("...")
    .EndIf
    Invoke RSlstrcmp, Edi, Eax
    Cmp Eax, 0
    Jne @F
    Mov Word Ptr [Edi], 0
@@: Ret
GetNoEllipsisString EndP

GetNoPrefixString Proc Uses Ecx Edx Esi lpszString:LPSTR
    Xor Ecx, Ecx
    Xor Edx, Edx
    Mov Esi, lpszString
    .If bAppUnicode
        .While (Word Ptr [Esi + Ecx])
            .If (Word Ptr [Esi + Ecx] != '&')
                Mov Ax, Word Ptr [Esi + Ecx]
                Mov Word Ptr [Esi + Edx], Ax
                Add Edx, 2
            .EndIf
            Add Ecx, 2
        .EndW
        Mov Word Ptr [Esi + Edx], 0
    .Else
        .While (Byte Ptr [Esi + Ecx])
            .If (Byte Ptr [Esi + Ecx] != '&')
                Mov Al, Byte Ptr [Esi + Ecx]
                Mov Byte Ptr [Esi + Edx], Al
                Add Edx, 1
            .EndIf
            Add Ecx, 1
        .EndW
        Mov Byte Ptr [Esi + Edx], 0
    .EndIf
    Ret
GetNoPrefixString EndP

GetRegistrySettings Proc
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAutoIndent, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.bAutoIndent, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("1")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBOM, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.bBOM, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szHideSelBar, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.bHideSelBar, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("1")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szHideSelection, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.bHideSelection, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szEndOfLine, lpszCommon
    Invoke Value, lpszCommon
    .If Eax < SDWord Ptr RSC_CR_LF || Eax > SDWord Ptr RSC_LF
        Xor Eax, Eax
    .EndIf
    Mov Cfg.lEndOfLine, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("4")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTabSize, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.lTabSize, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTabToSpaces, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.bTabToSpaces, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSpacesToTab, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.bSpacesToTab, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("1")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szToolbar, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.bToolbar, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("1")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szStatusbar, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.bStatusbar, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("80000005H")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBackColor, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.crBackColor, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("80000008H")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTextColor, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.crTextColor, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("8000000DH")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBackSelect, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.crBackSelect, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("8000000EH")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTextSelect, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.crTextSelect, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("00E0E0E0H")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSelBarColor, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.crSelBarColor, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("00F0F0F0H")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBackLocked, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.crBackLocked, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("00808080H")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTextLocked, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.crTextLocked, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("LastPath")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLastPath, Addr Cfg.szLastPath
    Invoke GetRightFormatText, lpszCommon, TextAddr("10")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontPoints, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.ef.lPoints, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("400")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontWeight, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.ef.lWeight, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontItalic, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.ef.bItalic, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontStrikethru, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.ef.bStrikethru, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontUnderline, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.ef.bUnderline, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("0")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontCharSet, lpszCommon
    Invoke Value, lpszCommon
    Mov Cfg.ef.dwCharSet, Eax
    Invoke GetRightFormatText, lpszCommon, TextAddr("Courier New")
    Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontName, lpszCommon
    Invoke RSlstrcpy, Addr Cfg.ef.szFaceName, lpszCommon
    Ret
GetRegistrySettings EndP

GetRightFormatText Proc lpszDest:LPSTR, lpszBuf:LPSTR
    .If bAppUnicode
        Invoke lstrlen, lpszBuf
        Inc Eax
        Shl Eax, 1
        Invoke MultiByteToWideChar, CP_ACP, 0, lpszBuf, (-1), lpszDest, Eax
    .Else
        Invoke lstrcpy, lpszDest, lpszBuf
    .EndIf
    Ret
GetRightFormatText EndP

RSChooseFont Proc lpcf:DWord
    Push lpcf
    .If bAppUnicode
        Mov Eax, ChooseFontW
    .Else
        Mov Eax, ChooseFontA
    .EndIf
    Call Eax
    Ret
RSChooseFont EndP

RSGetCurrentDirectory Proc nBufferLength:DWord, lpBuffer:LPTSTR
    Push lpBuffer
    Push nBufferLength
    .If bAppUnicode
        Mov Eax, GetCurrentDirectoryW
    .Else
        Mov Eax, GetCurrentDirectoryA
    .EndIf
    Call Eax
    Ret
RSGetCurrentDirectory EndP

RSGetWindowLong Proc hWnd:HWND, nIndex:LONG
    Push nIndex
    Push hWnd
    .If bAppUnicode
        Mov Eax, GetWindowLongW
    .Else
        Mov Eax, GetWindowLongA
    .EndIf
    Call Eax
    Ret
RSGetWindowLong EndP

RSGetWindowText Proc hWnd:HWND, lpString:LPSTR, nMaxCount:LONG
    Push nMaxCount
    Push lpString
    Push hWnd
    .If bAppUnicode
        Mov Eax, GetWindowTextW
    .Else
        Mov Eax, GetWindowTextA
    .EndIf
    Call Eax
    Ret
RSGetWindowText EndP

RSLoadString Proc hInstance:HINSTANCE, uID:UINT, lpszBuffer:LPTSTR, nBufferMax:LONG
    Push nBufferMax
    Push lpszBuffer
    Push uID
    Push hInstance
    .If bAppUnicode
        Mov Eax, LoadStringW
    .Else
        Mov Eax, LoadStringA
    .EndIf
    Call Eax
    Ret
RSLoadString EndP

RSlstrcat Proc lpString1:LPCTSTR, lpString2:LPCTSTR
    Push lpString2
    Push lpString1
    .If bAppUnicode
        Mov Eax, lstrcatW
    .Else
        Mov Eax, lstrcatA
    .EndIf
    Call Eax
    Ret
RSlstrcat EndP

RSlstrcmp Proc lpString1:LPCTSTR, lpString2:LPCTSTR
    Push lpString2
    Push lpString1
    .If bAppUnicode
        Mov Eax, lstrcmpW
    .Else
        Mov Eax, lstrcmpA
    .EndIf
    Call Eax
    Ret
RSlstrcmp EndP

RSlstrcmpi Proc lpString1:LPCTSTR, lpString2:LPCTSTR
    Push lpString2
    Push lpString1
    .If bAppUnicode
        Mov Eax, lstrcmpiW
    .Else
        Mov Eax, lstrcmpiA
    .EndIf
    Call Eax
    Ret
RSlstrcmpi EndP

RSlstrcpy Proc lpString1:LPCTSTR, lpString2:LPCTSTR
    Push lpString2
    Push lpString1
    .If bAppUnicode
        Mov Eax, lstrcpyW
    .Else
        Mov Eax, lstrcpyA
    .EndIf
    Call Eax
    Ret
RSlstrcpy EndP

RSlstrcpyn Proc lpString1:LPCTSTR, lpString2:LPCTSTR, iMaxLength:LONG
    Push iMaxLength
    Push lpString2
    Push lpString1
    .If bAppUnicode
        Mov Eax, lstrcpynW
    .Else
        Mov Eax, lstrcpynA
    .EndIf
    Call Eax
    Ret
RSlstrcpyn EndP

RSlstrlen Proc lpString:LPCTSTR
    Push lpString
    .If bAppUnicode
        Mov Eax, lstrlenW
    .Else
        Mov Eax, lstrlenA
    .EndIf
    Call Eax
    Ret
RSlstrlen EndP

RSMessageBox Proc hWnd:HWND, lpText:LPTSTR, lpCaption:LPTSTR, uType:UINT
    Push uType
    Push lpCaption
    Push lpText
    Push hWnd
    .If bAppUnicode
        Mov Eax, MessageBoxW
    .Else
        Mov Eax, MessageBoxA
    .EndIf
    Call Eax
    Ret
RSMessageBox EndP

RSSendMessage Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
    Push lParam
    Push wParam
    Push uMsg
    Push hWnd
    .If bAppUnicode
        Mov Eax, SendMessageW
    .Else
        Mov Eax, SendMessageA
    .EndIf
    Call Eax
    Ret
RSSendMessage EndP

SetEditorSettings Proc bFont:BOOL, bUpdate:BOOL
    .If bFont
        Invoke SendMessage, hWndEditor, RSM_CREATEFONT, TRUE, Addr Cfg.ef
    .EndIf
    Invoke SendMessage, hWndEditor, RSM_SETAUTOINDENT, Cfg.bAutoIndent, 0
    Invoke SendMessage, hWndEditor, RSM_SETWRITEBOM, Cfg.bBOM, 0
    Invoke SendMessage, hWndEditor, RSM_SETHIDESELECTION, Cfg.bHideSelection, 0
    Invoke SendMessage, hWndEditor, RSM_SETLINESAVEFORMAT, Cfg.lEndOfLine, 0
    Invoke SendMessage, hWndEditor, RSM_SETTABSIZE, Cfg.lTabSize, 0
    Invoke SendMessage, hWndEditor, RSM_SETTABTOSPACES, Cfg.bTabToSpaces, 0
    Invoke SendMessage, hWndEditor, RSM_SETSPACESTOTAB, Cfg.bSpacesToTab, 0
    Mov Eax, 14
    .If Cfg.bHideSelBar
        Xor Eax, Eax
    .EndIf
    Invoke SendMessage, hWndEditor, RSM_SETSELBARWIDTH, Eax, 0

    Invoke SendMessage, hWndEditor, RSM_SETBACKCOLOR, FALSE, Cfg.crBackColor
    Invoke SendMessage, hWndEditor, RSM_SETTEXTCOLOR, FALSE, Cfg.crTextColor
    Invoke SendMessage, hWndEditor, RSM_SETBACKSELECT, FALSE, Cfg.crBackSelect
    Invoke SendMessage, hWndEditor, RSM_SETTEXTSELECT, FALSE, Cfg.crTextSelect
    Invoke SendMessage, hWndEditor, RSM_SETBACKMARGIN, FALSE, Cfg.crSelBarColor
    Invoke SendMessage, hWndEditor, RSM_SETLOCKEDBACKCOLOR, bUpdate, Cfg.crBackLocked
    Invoke SendMessage, hWndEditor, RSM_SETLOCKEDTEXTCOLOR, bUpdate, Cfg.crTextLocked
    Ret
SetEditorSettings EndP

SetObjectText Proc hDlg:HWND, lStringID:LONG, lControlID:LONG, lpszBuf:LPSTR
    Invoke RSLoadString, App.Instance, lStringID, lpszBuf, MAX_PATH
    Invoke GetNoEllipsisString, lpszBuf
    Invoke GetWindowItem, hDlg, lControlID
    Invoke SetText, Eax, lpszBuf
    Ret
SetObjectText EndP

SetRegistrySettings Proc
    Invoke String, Cfg.bAutoIndent, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAutoIndent, lpszCommon
    Invoke String, Cfg.bBOM, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBOM, lpszCommon
    Invoke String, Cfg.bHideSelBar, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szHideSelBar, lpszCommon
    Invoke String, Cfg.bHideSelection, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szHideSelection, lpszCommon
    Invoke String, Cfg.lTabSize, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTabSize, lpszCommon
    Invoke String, Cfg.lEndOfLine, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szEndOfLine, lpszCommon
    Invoke String, Cfg.bTabToSpaces, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTabToSpaces, lpszCommon
    Invoke String, Cfg.bSpacesToTab, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSpacesToTab, lpszCommon
    Invoke String, Cfg.bToolbar, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szToolbar, lpszCommon
    Invoke String, Cfg.bStatusbar, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szStatusbar, lpszCommon
    Invoke String, Cfg.crBackColor, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBackColor, lpszCommon
    Invoke String, Cfg.crTextColor, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTextColor, lpszCommon
    Invoke String, Cfg.crBackSelect, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBackSelect, lpszCommon
    Invoke String, Cfg.crTextSelect, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTextSelect, lpszCommon
    Invoke String, Cfg.crSelBarColor, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szSelBarColor, lpszCommon
    Invoke String, Cfg.crBackLocked, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBackLocked, lpszCommon
    Invoke String, Cfg.crTextLocked, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTextLocked, lpszCommon
    Invoke String, Cfg.ef.lPoints, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontPoints, lpszCommon
    Invoke String, Cfg.ef.lWeight, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontWeight, lpszCommon
    Invoke String, Cfg.ef.bItalic, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontItalic, lpszCommon
    Invoke String, Cfg.ef.bStrikethru, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontStrikethru, lpszCommon
    Invoke String, Cfg.ef.bUnderline, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontUnderline, lpszCommon
    Invoke String, Cfg.ef.dwCharSet, lpszCommon, ecDecimal
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontCharSet, lpszCommon
    Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFontName, Addr Cfg.ef.szFaceName
    Ret
SetRegistrySettings EndP
